polybori::dd_operations< CCuddNavigator > Class Template Reference

`#include <pbori_algo_int.h>`

Inheritance diagram for polybori::dd_operations< CCuddNavigator >:

## Public Types

typedef DdManager * | manager_type
typedef CCuddNavigator | navigator
Public Types inherited from polybori::CAuxTypes
typedef bool | bool_type
| Type for standard true/false statements. More...
typedef std::size_t | size_type
| Type for lengths, dimensions, etc. More...
typedef int | deg_type
| Type for polynomial degrees (ranges from -1 to maxint) More...
typedef int | integer_type
| Type for integer numbers. More...
typedef int | idx_type
| Type for indices. More...
typedef std::size_t | hash_type
| Type for hashing. More...
typedef unsigned int | errornum_type
| Type used to store error codes. More...
typedef short int | comp_type
| Type for comparisons. More...
typedef int | ordercode_type
| Type for ordering codes. More...
typedef const char * | errortext_type
| Type used to verbose error information. More...
typedef std::ostream | ostream_type
| Type for out-stream. More...
typedef const char * | vartext_type
| Type for setting/getting names of variables. More...
typedef unsigned long | large_size_type
| large size_type (necessary?) More...
typedef std::size_t | refcount_type
| Type for counting references. More...

## Public Member Functions

| dd_operations (manager_type man)
void | replacingUnite (navigator &newNode, const navigator &first, const navigator &second) const
void | uniteAssign (navigator &first, const navigator &second) const
void | diffAssign (navigator &first, const navigator &second) const
navigator | diff (const navigator &first, const navigator &second) const
void | replacingNode (navigator &newNode, idx_type idx, navigator &first, navigator &second) const
void | newNodeAssign (idx_type idx, navigator &thenNode, const navigator &elseNode) const
void | multiplesAssign (navigator &node, idx_type idx) const
void | productAssign (navigator &node, idx_type idx) const
void | assign (navigator &first, const navigator &second) const
void | replace (navigator &first, const navigator &second) const
size_type | nSupport (const navigator &node) const
size_type | length (const navigator &node) const
navigator & | newNode (navigator &node) const
void | kill (navigator &node) const

## Protected Attributes

manager_type | mgr

## Member Typedef Documentation

typedef DdManager* polybori::dd_operations< CCuddNavigator >::manager_type

typedef CCuddNavigator polybori::dd_operations< CCuddNavigator >::navigator

## Constructor & Destructor Documentation

polybori::dd_operations< CCuddNavigator >::dd_operations | ( | manager_type | man) |  |

inline

## Member Function Documentation

void polybori::dd_operations< CCuddNavigator >::assign | ( | navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::CCuddNavigator::incRef().

navigator polybori::dd_operations< CCuddNavigator >::diff | ( | const navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::apply_cudd_function(), Cudd_zddDiff, and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::diffAssign | ( | navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::apply_assign_cudd_function(), Cudd_zddDiff, and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::kill | ( | navigator & | node) |  | const

inline

References polybori::recursive_dec_ref().

size_type polybori::dd_operations< CCuddNavigator >::length | ( | const navigator & | node) |  | const

inline

References polybori::CCuddNavigator::getNode(), and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::multiplesAssign | ( | navigator & | node,
|  | idx_type | idx
| ) |  | const

inline

navigator& polybori::dd_operations< CCuddNavigator >::newNode | ( | navigator & | node) |  | const

inline

References polybori::CCuddNavigator::incRef().

void polybori::dd_operations< CCuddNavigator >::newNodeAssign | ( | idx_type | idx,
|  | navigator & | thenNode,
|  | const navigator & | elseNode
| ) |  | const

inline

References cuddZddGetNode, polybori::CCuddNavigator::getNode(), polybori::CCuddNavigator::incRef(), PBORI_PREFIX, and polybori::recursive_dec_ref().

size_type polybori::dd_operations< CCuddNavigator >::nSupport | ( | const navigator & | node) |  | const

inline

References polybori::CCuddNavigator::getNode(), and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::productAssign | ( | navigator & | node,
|  | idx_type | idx
| ) |  | const

inline

References Cudd_ReadZero, and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::replace | ( | navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::recursive_dec_ref().

void polybori::dd_operations< CCuddNavigator >::replacingNode | ( | navigator & | newNode,
|  | idx_type | idx,
|  | navigator & | first,
|  | navigator & | second
| ) |  | const

inline

References cuddZddGetNode, polybori::CCuddNavigator::getNode(), polybori::CCuddNavigator::incRef(), PBORI_PREFIX, and polybori::recursive_dec_ref().

void polybori::dd_operations< CCuddNavigator >::replacingUnite | ( | navigator & | newNode,
|  | const navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::apply_replacing_cudd_function(), Cudd_zddUnion, and PBORI_PREFIX.

void polybori::dd_operations< CCuddNavigator >::uniteAssign | ( | navigator & | first,
|  | const navigator & | second
| ) |  | const

inline

References polybori::apply_assign_cudd_function(), Cudd_zddUnion, and PBORI_PREFIX.

## Member Data Documentation

manager_type polybori::dd_operations< CCuddNavigator >::mgr

protected

The documentation for this class was generated from the following file:

- pbori_algo_int.h